﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

namespace Chapter_04
{
    class Customer
    {
        public string Name;
    }

    class PotentialCustomer : Customer
    {
        public string SalesPerson;
    }

    class RegularCustomer : Customer
    {
        public DateTime LastPurchase;
    }

    struct Money
    {
        public decimal Amount;
    }

    class Program
    {
        static void Main(string[] args)
        {
            // object for generic programming

            decimal amount = 3.50m;
            object obj1 = amount;
            Customer cust = new Customer();
            object obj2 = cust;

            Customer cust2 = (Customer)obj2;

            // ArrayList & Reference Types

            ArrayList customers = new ArrayList();

            Customer cust3 = new Customer();
            cust3.Name = "John Smith";
            Customer cust4 = new Customer();
            cust4.Name = "Jane Doe";

            customers.Add(cust3);
            customers.Add(cust4);

            foreach (Customer custItem in customers)
            {
                Console.WriteLine("Customer Name: {0}", custItem.Name);
            }

            decimal amountIn = 3.50m;
            object obj = amountIn; // box
            decimal amountOut = (decimal)obj; // unbox

            // ArrayList and Value types
            ArrayList prices = new ArrayList();

            decimal amount1 = 7.50m;
            decimal amount2 = 1.95m;
            prices.Add(amount1);
            prices.Add(amount2);

            foreach (decimal amountItem in prices)
            {
                Console.WriteLine("Amount: {0}", amountItem);
            }

            // Reference type assignment

            Customer cust5 = new Customer();
            cust5.Name = "John Smith";
            Customer cust6 = new Customer();
            cust6.Name = "Jane Doe";

            Console.WriteLine("Before Reference Assignment:");
            Console.WriteLine("cust5: {0}", cust5.Name);
            Console.WriteLine("cust6: {0}", cust6.Name);

            cust5 = cust6;

            Console.WriteLine("After Reference Assignment:");
            Console.WriteLine("cust5: {0}", cust5.Name);
            Console.WriteLine("cust6: {0}", cust6.Name);

            cust6.Name = "John Smith";

            Console.WriteLine("After modifying the contents of a Reference type object:");
            Console.WriteLine("cust5: {0}", cust5.Name);
            Console.WriteLine("cust6: {0}", cust6.Name);

            // Value type assignment

            Money cash1;
            Money cash2;

            cash1.Amount = 50.00m;
            cash2.Amount = 75.00m;

            Console.WriteLine("Before Value Assignment:");
            Console.WriteLine("cash1.Amount: {0}", cash1.Amount);
            Console.WriteLine("cash2.Amount: {0}", cash2.Amount);

            cash1 = cash2;

            Console.WriteLine("After Value Assignment:");
            Console.WriteLine("cash1.Amount: {0}", cash1.Amount);
            Console.WriteLine("cash2.Amount: {0}", cash2.Amount);

            cash2.Amount = 50.00m;

            Console.WriteLine("After modifying contents of Value type object:");
            Console.WriteLine("cash1.Amount: {0}", cash1.Amount);
            Console.WriteLine("cash2.Amount: {0}", cash2.Amount);

            // GUIDs

            Guid uniqueVal1 = new Guid();
            Console.WriteLine("uniqueVal1: {0}", uniqueVal1.ToString());

            uniqueVal1 = new Guid("89e9f11b-00ee-47dc-be15-01f70eeac3f9");
            Console.WriteLine("uniqueVal1: {0}", uniqueVal1.ToString());
            
            uniqueVal1 = Guid.NewGuid();
            Console.WriteLine("uniqueVal1: {0}", uniqueVal1.ToString());

            // DateTime's

            DateTime date = new DateTime();
            Console.WriteLine("date: {0}", date);

            date = new DateTime(2008, 7, 4, 21, 35, 15, 777);

            Console.WriteLine("date: {0}", date);

            date = DateTime.Now;
            Console.WriteLine("date: {0}", date);

            Console.WriteLine(
                "{0} day {1} of the month is day {2} of the year",
                date.DayOfWeek, date.Day, date.DayOfYear);

            Console.WriteLine("date before AddDays(1): {0}", date);
            date.AddDays(1);
            Console.WriteLine("date after AddDays(1): {0}", date);

            Console.WriteLine("date before AddDays(1): {0}", date);
            date = date.AddDays(1);
            Console.WriteLine("date after AddDays(1): {0}", date);

            int testIterations = 5; // int.MaxValue / 4;
            DateTime start = DateTime.Now;

            for (int i = 0; i < testIterations; i++)
            {
                Money cash;
                cash.Amount = decimal.MaxValue;
            }

            DateTime finish = DateTime.Now;
            TimeSpan elapsedTime = finish - start;

            Console.WriteLine("Elapsed Time: {0}", elapsedTime);

            Console.Write("Please enter a date (mm/dd/yyyy): ");
            string dateStr = Console.ReadLine();

            date = DateTime.Parse(dateStr);

            Console.WriteLine("You entered '{0}'", date);

            Console.WriteLine("Date Only: {0:d}", date);
            Console.WriteLine("Date Only: {0}", date.ToString("d"));

            date = new DateTime(2008, 7, 4, 21, 35, 15, 777);
            
            Console.WriteLine("d: {0:d}", date);
            Console.WriteLine("D: {0:D}", date);
            Console.WriteLine("t: {0:t}", date);
            Console.WriteLine("T: {0:T}", date);
            Console.WriteLine("f: {0:f}", date);
            Console.WriteLine("F: {0:F}", date);
            Console.WriteLine("g: {0:g}", date);
            Console.WriteLine("G: {0:G}", date);
            Console.WriteLine("m: {0:m}", date);
            Console.WriteLine("M: {0:M}", date);
            Console.WriteLine("r: {0:r}", date);
            Console.WriteLine("R: {0:R}", date);
            Console.WriteLine("s: {0:s}", date);
            Console.WriteLine("u: {0:u}", date);
            Console.WriteLine("U: {0:U}", date);
            Console.WriteLine("y: {0:y}", date);
            Console.WriteLine("Y: {0:Y}", date);

            Console.WriteLine("MM/dd/yy: {0:MMMM/dddd/yy}", date);

            // Nullable Types

            DateTime? createDate = null;

            bool isNull;

            isNull = createDate == null;
            isNull = createDate.HasValue;

            if (createDate == null)
            {
                createDate = DateTime.Now;
            }

            createDate = createDate ?? DateTime.Now;

            DateTime? defaultDate = null;

            createDate = createDate ?? defaultDate ?? DateTime.Now;
        }
    }
}
