﻿using System;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Text;

class MoneyClient
{
    static void Main()
    {
        const int StreamSize = 256;
        const int Port = 2010;
        const string LocalHost = "localhost";
        var ipEndPt = new IPEndPoint(
            new IPAddress(
                new byte[] { 127, 0, 0, 1 }),
            Port);
        var AsciiEnc = new ASCIIEncoding();
        var inStream = new byte[StreamSize];
        var outStream = new byte[StreamSize];

        string freeAdvice;
        string choice = "Q";

        do
        {
            try
            {
                Console.WriteLine("\nMoney Line\n");
                Console.WriteLine("1 - Get Advice");
                Console.WriteLine("Q - Quit");
                Console.Write("\nPlease Choose:  ");
                choice = Console.ReadLine();
                Console.WriteLine();

                var myClient = new TcpClient(LocalHost, Port);
                Stream myStream = myClient.GetStream();

                outStream = AsciiEnc.GetBytes(
                    "What is the secret of making money?");

                if (choice == "1")
                {
                    // send request to server
                    myStream.Write(
                        outStream, 0, outStream.Length);

                    // clean garbage chars from byte array
                    for (int i = 0; i < inStream.Length; i++)
                    {
                        inStream[i] = 0;
                    }

                    // retrieve response from server
                    myStream.Read(
                        inStream, 0, inStream.Length);
                    freeAdvice = AsciiEnc.GetString(
                        inStream, 0, inStream.Length);
                    Console.WriteLine("Server Response: {0}",
                                       freeAdvice);
                }
                else
                {
                    // close session with server
                    outStream = AsciiEnc.GetBytes("bye");
                    myStream.Write(
                        outStream, 0, outStream.Length);
                }
            }
            catch (InvalidOperationException ioe)
            {
                Console.WriteLine(
                   "Invalid Operation Message: {0}",
                    ioe.Message);
            }
            catch (Exception e)
            {
                Console.WriteLine(
                    "Generic Exception Message: {0}",
                     e.Message);
            }
        } while (choice == "1");
    }
}