using System;
using System.Diagnostics;

	/// <summary>
	///		BooleanSwitch Demo.
	/// </summary>
class BooleanSwitchDemo
{
	static BooleanSwitch traceOutput = new 
		BooleanSwitch("TraceOutput", "Boolean Switch Demo");

	void SetupDebugListener()
	{
		TextWriterTraceListener myListener = 
			new TextWriterTraceListener(Console.Out);

		Trace.Listeners.Add(myListener);
	}
	
	void CheckState()
	{
		Trace.WriteLineIf(traceOutput.Enabled, "Debug: Entered CheckState()");
	}

	static void Main(string[] args)
	{
		BooleanSwitchDemo bsd = new BooleanSwitchDemo();

		bsd.SetupDebugListener();
		bsd.CheckState();

		Console.ReadLine();
	}
}
