#define DEBUG

using System;
using System.Diagnostics;

	/// <summary>
	///		Conditional Debug Demo.
	/// </summary>
class ConditionalDebugDemo
{
	static bool Debugging = true;

	[Conditional("DEBUG")]
	static void SetupDebugListener()
	{
		TextWriterTraceListener myListener = 
			new TextWriterTraceListener(Console.Out);

		Debug.Listeners.Add(myListener);
	}

	[Conditional("DEBUG")]
	static void CheckState()
	{
		Debug.WriteLineIf(Debugging, "Debug: Entered CheckState()");
	}

	static void Main(string[] args)
	{
		SetupDebugListener();
		CheckState();

		Console.ReadLine();
	}
}
