using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using System.Diagnostics;

namespace OrderingClient
{
	/// <summary>
	/// Performance Counter Demo.
	/// </summary>
	public class OrderClient : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label maxOrdLbl;
		private System.Windows.Forms.Label curOrdLbl;
		private System.Windows.Forms.TextBox maxOrdTxt;
		private System.Windows.Forms.Label curOrdResultLbl;
		private System.Windows.Forms.Button updateBtn;

		private int maxOrders;
		private int curOrders;
		private OrderProcessor orderProc;
		private System.Windows.Forms.Timer orderTimer;
		private System.Windows.Forms.Timer countTimer;
		private System.Windows.Forms.Label threadLbl;
		private System.Windows.Forms.Label threadResultLbl;
		private System.Diagnostics.PerformanceCounter threadCounter;
		private System.ComponentModel.IContainer components;

		public OrderClient()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			maxOrders = 10;
			maxOrdTxt.Text = maxOrders.ToString();
			orderProc = new OrderProcessor();
			curOrders = orderProc.CurNoOrders;
			curOrdResultLbl.Text = curOrders.ToString();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.maxOrdTxt = new System.Windows.Forms.TextBox();
			this.updateBtn = new System.Windows.Forms.Button();
			this.maxOrdLbl = new System.Windows.Forms.Label();
			this.curOrdLbl = new System.Windows.Forms.Label();
			this.orderTimer = new System.Windows.Forms.Timer(this.components);
			this.curOrdResultLbl = new System.Windows.Forms.Label();
			this.countTimer = new System.Windows.Forms.Timer(this.components);
			this.threadLbl = new System.Windows.Forms.Label();
			this.threadResultLbl = new System.Windows.Forms.Label();
			this.threadCounter = new System.Diagnostics.PerformanceCounter();
			((System.ComponentModel.ISupportInitialize)(this.threadCounter)).BeginInit();
			this.SuspendLayout();
			// 
			// maxOrdTxt
			// 
			this.maxOrdTxt.Location = new System.Drawing.Point(152, 24);
			this.maxOrdTxt.Name = "maxOrdTxt";
			this.maxOrdTxt.TabIndex = 2;
			this.maxOrdTxt.Text = "";
			this.maxOrdTxt.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// updateBtn
			// 
			this.updateBtn.Location = new System.Drawing.Point(104, 152);
			this.updateBtn.Name = "updateBtn";
			this.updateBtn.TabIndex = 4;
			this.updateBtn.Text = "Update";
			this.updateBtn.Click += new System.EventHandler(this.updateBtn_Click);
			// 
			// maxOrdLbl
			// 
			this.maxOrdLbl.Location = new System.Drawing.Point(40, 24);
			this.maxOrdLbl.Name = "maxOrdLbl";
			this.maxOrdLbl.TabIndex = 0;
			this.maxOrdLbl.Text = "Max Orders:";
			this.maxOrdLbl.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// curOrdLbl
			// 
			this.curOrdLbl.Location = new System.Drawing.Point(40, 64);
			this.curOrdLbl.Name = "curOrdLbl";
			this.curOrdLbl.TabIndex = 1;
			this.curOrdLbl.Text = "Current Orders:";
			this.curOrdLbl.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// orderTimer
			// 
			this.orderTimer.Enabled = true;
			this.orderTimer.Interval = 2000;
			this.orderTimer.Tick += new System.EventHandler(this.orderTimer_Tick);
			// 
			// curOrdResultLbl
			// 
			this.curOrdResultLbl.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.curOrdResultLbl.Location = new System.Drawing.Point(152, 64);
			this.curOrdResultLbl.Name = "curOrdResultLbl";
			this.curOrdResultLbl.Size = new System.Drawing.Size(100, 20);
			this.curOrdResultLbl.TabIndex = 3;
			this.curOrdResultLbl.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// countTimer
			// 
			this.countTimer.Enabled = true;
			this.countTimer.Interval = 1000;
			this.countTimer.Tick += new System.EventHandler(this.countTimer_Tick);
			// 
			// threadLbl
			// 
			this.threadLbl.Location = new System.Drawing.Point(40, 104);
			this.threadLbl.Name = "threadLbl";
			this.threadLbl.TabIndex = 1;
			this.threadLbl.Text = "Thread Count:";
			this.threadLbl.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// threadResultLbl
			// 
			this.threadResultLbl.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.threadResultLbl.Location = new System.Drawing.Point(152, 104);
			this.threadResultLbl.Name = "threadResultLbl";
			this.threadResultLbl.Size = new System.Drawing.Size(100, 20);
			this.threadResultLbl.TabIndex = 3;
			this.threadResultLbl.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// threadCounter
			// 
			this.threadCounter.CategoryName = ".NET CLR LocksAndThreads";
			this.threadCounter.CounterName = "# of current physical Threads";
			this.threadCounter.InstanceName = "OrderingClient";
			// 
			// OrderClient
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(288, 197);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.threadLbl,
																		  this.threadResultLbl,
																		  this.updateBtn,
																		  this.curOrdResultLbl,
																		  this.maxOrdTxt,
																		  this.curOrdLbl,
																		  this.maxOrdLbl});
			this.Name = "OrderClient";
			this.Text = "Order Client";
			((System.ComponentModel.ISupportInitialize)(this.threadCounter)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new OrderClient());
		}

		private void updateBtn_Click(object sender, System.EventArgs e)
		{
			maxOrders = Convert.ToInt32(maxOrdTxt.Text);
		}

		private void orderTimer_Tick(object sender, System.EventArgs e)
		{
			orderTimer.Enabled = false;

			Thread th = new Thread(new ThreadStart(ProcessOrders));
			th.Start();

			orderTimer.Enabled = true;
		}

		private void countTimer_Tick(object sender, System.EventArgs e)
		{
			countTimer.Enabled = false;

			curOrdResultLbl.Text = orderProc.CurNoOrders.ToString();
			threadResultLbl.Text = threadCounter.NextValue().ToString();

			countTimer.Enabled = true;
		}

		private void ProcessOrders()
		{
			for (curOrders = orderProc.CurNoOrders;
				curOrders <= maxOrders; 
				curOrders++)
			{
				curOrdResultLbl.Text = curOrders.ToString();

				orderProc.ProcessOrder();
			}
		}

	}
}
